/*
Large Assignment 1: LSystems
Name: Andy Thornhill
Email: athor@unm.edu
Course: CS49 Computational Fabrication
Date: 9/14/2023

LSystem, when run, draws a Yucca LSystem on the screen to increasing detail.
To save a screenshot of what is currently on the screen, press the spacebar.
*/

import Turtle .*;
LSystemClass l;
Turtle t;
String word;

void setup(){
 size (800,800);
 background(80);
 stroke(255);
 l = new LSystemClass(height-20, 40, .55);
 t = new Turtle(this);
 frameRate(1);
}

void draw(){
  background(80);
  t.setX(width/2);
  t.setY(height-50);
  l.iteration();
  l.drawLSystem(t);
}

void keyPressed(){
   if(key==' ') {
      String filename = "LSystem" + random(0,100) + ".png";
      save(filename);
   }
}
