class LSystemClass{
 String axiom = "X";
                    
 String [][] rules = { {"F", "FF", "FF", "F", "FF"}, //Randomly decide length
                       {"X", "[+X][FX][-X]F", "[X][X]F", "[X][X]F", "[+X][-X][X][X]F", }, //Start with X not F
                       {"+", "+", "+", "+", "+"},
                       {"-", "-", "-", "-", "-"},
                       {"[", "[", "[", "[", "["},
                       {"]", "]", "]", "]", "]"}};
 String word;
 int angle;
 float scale;
 float size;
 int iterations;
 
 LSystemClass (float size, int angle, float scale){
   word = axiom;
   this.size = size;
   this.angle = angle;
   this.scale = scale;
   iterations = 0;
 }
 
 void iteration(){
   String result = "";
   char s;
   for(int i = 0; i < word.length(); i++){
     s = word.charAt(i);
     for(int j = 0; j < rules.length; j++){
       if(s == rules[j][0].charAt(0)){
         result = result + rules[j][(int)random(1,5)];
         break;
       }
     }
   }
   size = size*scale;
   iterations ++;
   word = result;
   println(word);
 }



  void drawLSystem(Turtle t){
    char s;
    for(int i = 0; i < word.length(); i++){
      s = word.charAt(i);
      if(s == 'F') t.forward(size);
      else if(s == '+') t.right(angle + ((int)random(-15,15)));
      else if(s == '-') t.left(angle + ((int)random(-15,15)));
      else if(s == '[') t.push();
      else if(s == ']') t.pop();
    }
  }
}
